Description
This is a follow up of https:/community.theforeman.org/t/when-should-the-installer-restart-puma/26162

To recap the issue: when you install or update a plugin today, puma needs to be restarted to load the new code, but this only
happens if the installer detects this situation.

The detection, today, only detects two cases: a plugin was installed by the installer or the plugin got updated via packaging and has a
new migration available.

A lot of .z plugin updates don't carry new migrations, and thus go undetected and break things (like views that try to load files that are
gone and similar)

In the above discussion, we came to the conclusion we should try to detect these cases better and trigger a puma restart.

There are different proposals, but all have one in common: a package installation/upgrade somewhow marks the system as "dirty"
("changed") and this can be used as a flag for the restart.

There is an interesting feature in systemd (https:/fedoraproject.org/wiki/Changes/Restart_services_at_end_of_rpm_transaction) that
could be used for that, but it only would work on EL9 and other "modern" installs, while we also need to support "legacy" systems like
ELS.

So the probably best next thing would be to have packaging touch a file somewhere (rails tmp?) and the installer ensuring this file as
absent with a notification towards the service definition, thus triggering a restart.
The file in rails tmp also could be used as a source for Ul notifications about a needed restart.

Related issues:
Related to Installer - Bug #36682: installer fails to call Foreman_host when ... New

Associated revisions

Revision 10bcb5cc - 05/06/2022 12:37 AM - Evgeni Golov

Fixes #34602 - restart services after plugin installation

Revision 1df76444 - 05/06/2022 07:18 AM - Evgeni Golov
Refs #34602 - drop restart_required_changed_plugins file on boot

The file indicates that new plugins were installed and we need to
restart Rails.

History

#1 - 04/29/2022 12:52 PM - The Foreman Bot
- Status changed from New to Ready For Testing
https://community.theforeman.org/t/when-should-the-installer-restart-puma/26162
https://fedoraproject.org/wiki/Changes/Restart_services_at_end_of_rpm_transaction

- Assignee set to Evgeni Golov

- Pull request https://github.com/theforeman/foreman-packaging/pull/7853 added

#2 - 04/29/2022 01:03 PM - The Foreman Bot
- Pull request https://github.com/theforeman/puppet-foreman/pull/1046 added

#3 - 05/02/2022 08:25 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman-packaging/pull/7855 added

#4 - 05/06/2022 12:37 AM - The Foreman Bot
- Fixed in Releases 3.3.0 added

#5 - 05/06/2022 01:01 AM - Evgeni Golov
- Status changed from Ready For Testing to Closed

Applied in changeset puppet-foreman|10bcb5cc1b783381b0a58771eecd264c5d38f5fc.

#6 - 05/13/2022 10:59 AM - Amit Upadhye

- Subject changed from detect plugin installation and trigger puma restart to Detect plugin installation and trigger Puma restart

#7 - 08/15/2023 11:44 AM - Evgeni Golov

- Related to Bug #36682: installer fails to call Foreman_host when plugins were updated via packages but service was not restarted added
